package cs108.observer;

import java.util.ArrayList;
import java.util.List;

public abstract class Cell implements Subject {
	private final String name;
	private final List<Observer> observers;

	public Cell(String name) {
		this.name = name;
		this.observers = new ArrayList<>();
	}

	public String name() {
		return name;
	}

	@Override
	public void addObserver(Observer o) {
		observers.add(o);
	}

	@Override
	public void removeObserver(Observer o) {
		observers.remove(o);
	}

	protected void notifyObservers() {
		for (Observer o: observers)
			o.update(this);
	}

	abstract public int value();
}
