package cs108.observer;

public final class DivCell extends Cell implements Observer {
	private final Cell c1, c2;
	private int div;
	
	public DivCell(String name, Cell c1, Cell c2) {
		super(name);
		this.c1 = c1;
		this.c2 = c2;
		this.div = c1.value() / c2.value();
		
		c1.addObserver(this);
		c2.addObserver(this);
	}

	@Override
	public int value() {
		return div;
	}
	
	@Override
	public void update(Subject s) {
		int newDiv = c1.value() / c2.value();
		if (newDiv != div) {
			div = newDiv;
			notifyObservers();
		}
	}
	
	@Override
	public String toString() {
		return String.format("%d [=%s/%s]", div, c1.name(), c2.name());
	}
}
