package cs108.observer;

import java.util.Arrays;
import java.util.List;

import javax.swing.SwingUtilities;

import cs108.observer.gui.Spreadsheet;

public final class Main {
	public static void main(String[] args) {
		Cell A1 = new ValueCell("A1", 10);
		Cell A2 = new ValueCell("A2", 12);
		Cell A3 = new SumCell("A3", A1, A2);

		Cell B1 = new ValueCell("B1", 6);
		Cell B2 = new ValueCell("B2", 12);
		Cell B3 = new SumCell("B3", B1, B2);

		Cell C1 = new ValueCell("C1", 0);
		Cell C2 = new ValueCell("C2", 0);
		Cell C3 = new SumCell("C3", A3, B3);

		List<Cell> cells = List.of(
				A1, B1, C1,
				A2, B2, C2,
				A3, B3, C3);
		Spreadsheet spreadsheet = new Spreadsheet(cells);

		// La ligne suivante est en gros équivalente à : spreadsheet.createUI();
		SwingUtilities.invokeLater(spreadsheet::createUI);
	}
}
