package cs108.observer;

public final class ValueCell extends Cell {
	private int value;
	
	public ValueCell(String name, int initialValue) {
		super(name);
		this.value = initialValue;
	}
	
	@Override
	public int value() {
		return value;
	}
	
	public void setValue(int newValue) {
		if (newValue != value) {
			value = newValue;
			notifyObservers();
		}
	}
	
	@Override
	public String toString() {
		return String.format("%d", value);
	}
}
